<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_AlternateReceiptType ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_AlternateReceiptType extends AbstractStructArrayBase
{
    /**
     * The AlternateReceiptType
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_AlternateReceiptType[]
     */
    public $AlternateReceiptType;
    /**
     * Constructor method for ArrayOfJP_AlternateReceiptType
     * @uses ArrayOfJP_AlternateReceiptType::setAlternateReceiptType()
     * @param \StructType\JP_AlternateReceiptType[] $alternateReceiptType
     */
    public function __construct(array $alternateReceiptType = array())
    {
        $this
            ->setAlternateReceiptType($alternateReceiptType);
    }
    /**
     * Get AlternateReceiptType value
     * @return \StructType\JP_AlternateReceiptType[]|null
     */
    public function getAlternateReceiptType()
    {
        return $this->AlternateReceiptType;
    }
    /**
     * This method is responsible for validating the values passed to the setAlternateReceiptType method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAlternateReceiptType method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAlternateReceiptTypeForArrayConstraintsFromSetAlternateReceiptType(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfJP_AlternateReceiptTypeAlternateReceiptTypeItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_AlternateReceiptTypeAlternateReceiptTypeItem instanceof \StructType\JP_AlternateReceiptType) {
                $invalidValues[] = is_object($arrayOfJP_AlternateReceiptTypeAlternateReceiptTypeItem) ? get_class($arrayOfJP_AlternateReceiptTypeAlternateReceiptTypeItem) : sprintf('%s(%s)', gettype($arrayOfJP_AlternateReceiptTypeAlternateReceiptTypeItem), var_export($arrayOfJP_AlternateReceiptTypeAlternateReceiptTypeItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The AlternateReceiptType property can only contain items of type \StructType\JP_AlternateReceiptType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set AlternateReceiptType value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_AlternateReceiptType[] $alternateReceiptType
     * @return \ArrayType\ArrayOfJP_AlternateReceiptType
     */
    public function setAlternateReceiptType(array $alternateReceiptType = array())
    {
        // validation for constraint: array
        if ('' !== ($alternateReceiptTypeArrayErrorMessage = self::validateAlternateReceiptTypeForArrayConstraintsFromSetAlternateReceiptType($alternateReceiptType))) {
            throw new \InvalidArgumentException($alternateReceiptTypeArrayErrorMessage, __LINE__);
        }
        $this->AlternateReceiptType = $alternateReceiptType;
        return $this;
    }
    /**
     * Add item to AlternateReceiptType value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_AlternateReceiptType $item
     * @return \ArrayType\ArrayOfJP_AlternateReceiptType
     */
    public function addToAlternateReceiptType(\StructType\JP_AlternateReceiptType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_AlternateReceiptType) {
            throw new \InvalidArgumentException(sprintf('The AlternateReceiptType property can only contain items of type \StructType\JP_AlternateReceiptType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->AlternateReceiptType[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_AlternateReceiptType|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_AlternateReceiptType|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_AlternateReceiptType|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_AlternateReceiptType|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_AlternateReceiptType|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string AlternateReceiptType
     */
    public function getAttributeName()
    {
        return 'AlternateReceiptType';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfJP_AlternateReceiptType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
